library Joy3;

uses
  Forms,inifiles,
  wintypes,
  winprocs,
  mmsystem,
  dialogs,
  sysutils,
  Unit1 in 'UNIT1.PAS' {Form1};
  var started:boolean;
  var gnum:byte;
  var jp,dj,ty:array[1..8] of string;
var num:string;
var x:tinifile;
var si:tinifile;
var noj:byte;
const
JDD_GETNUMDEVS :   longint=  DRV_RESERVED+$0001;
JDD_GETDEVCAPS :  longint=   DRV_RESERVED+$0002;
JDD_GETPOS      :  longint=  DRV_RESERVED+$0101;
JDD_SETCALIBRATION :longint= DRV_RESERVED+$0102;
const maxjoy=$FFF9;
var running:boolean;
var ghInstance:longint;
{2305;}
var b1,b2,b3,b4{,x1,y1,x2,y2}:longint;
var v:longint;
var c,p:longint;
var ports,port2:longint;
var JOYSTICKPORT:longint;

Type
  TJoyStick = Record
                x1,x2,y1,y2 : longint; {x,y position values}
                a,b,c,d : boolean;  {boolean button values}
                btns : longint;        {numeric button value}
              end;
var Joysticks : Tjoystick;
var v1,v2,v3,v4:word;
{$R *.RES}
{$D DESCRIPTION : bios joy 2012}

Function ReadJoyStick : TJoyStick;
var
  x1,x2,y1,y2 :word;
  btns : byte;
begin
   asm              { BIOS call to read joystick (int$15)      }
     MOV AH, $84    { only permitted in 16bit code ie Delphi 1 }
     MOV DX, $0001  { for 32bit code use direct X instead.     }
     INT $15
     MOV x1, AX
     MOV y1, BX
     MOV x2, CX
     MOV y2, DX
     MOV AH, $84
     MOV DX, $0000
     INT $15
     MOV btns, AL
   end;
   result.x1:=x1;
   result.y1:=y1;
   result.x2:=x2;
   result.y2:=y2;
   result.a := not(btns and 16 = 16);
   result.b := not(btns and 32 = 32);
   result.c := not(btns and 64 = 64);
   result.d := not(btns and 128 = 128);
   result.btns := btns;
end;




function inttobin(Value: Longint): string;
var
  Ch: Char;
begin
  Result :='';
  repeat
    Ch :='0';
    Inc(Ch, Value mod 2);
    if Ch >'9' then Inc(Ch, 7);
    Insert( Ch, Result, 1);
    Value :=Value div 2;
  until Value =0;
  while length(result)<8 do begin
result:='0'+result;
  end;
  end;

function inttobin2(Value: Longint): string;
var
  Ch: Char;
  var x:byte;
begin
  Result :='';
  repeat
    Ch :='0';
    Inc(Ch, Value mod 2);
    if Ch >'9' then Inc(Ch, 7);
    Insert( Ch, Result, 1);
    Value :=Value div 2;
  until Value =0;
  while length(result)<8 do begin
result:='0'+result;
  end;
end;





function getnumdevs:longint; export;
var e,a:longint;
begin
result:=0;
if(started=false)then begin
x:=tinifile.create('gameport.ini');
end;


dj[1]:=x.readstring('bios','dule joy','1');
if(dj[1]='2')then begin
result:=2;
end;

if(result=0)then result:=1;
if(started=false)then begin x.free;end;

end;


function getpos(Id,lparam1,lparam2:longint):byte; export;
var st:string;
var nog,eh:byte;var jij:pjoyinfo;
var m,i,a,q:longint;
begin
result:=0;
joysticks.x1:=0;
joysticks.x2:=0;
joysticks.y1:=0;
joysticks.y2:=0;
joysticks.a:=false;
joysticks.b:=false;
joysticks.c:=false;
joysticks.d:=false;
b1:=0;b2:=0;b3:=0;b4:=0;

JoySticks := readJoyStick;

if(joysticks.a=true)then begin b1:=1;end;
if(joysticks.b=true)then begin b2:=1;end;
if(joysticks.c=true)then begin b3:=1;end;
if(joysticks.d=true)then begin b4:=1;end;

if(id>0)then begin end;
eh:=0;

if(lparam1 > 0) then begin
jij:=pjoyinfo(lparam1);
jij^.wzpos:=0;
jij^.wButtons:=0;
jij^.wxpos:=1;
jij^.wypos:=1;
{if(si.readstring('joy','nes','regular')='super')then begin}

jij^.wxpos:=32000;
jij^.wypos:=32000;
{jij^.wxpos:=y1;
jij^.wypos:=x1;}
{v1:=strtoint(ty[1]{x.readstring('game'+num,'type','1'));}

v2:=1;
if(dj[1]='2')then begin
v2:=2;
end;


if(id=0)then begin

if(joysticks.x1>(50+10)) then begin jij^.wxpos:=maxjoy;end;
if(joysticks.x1<(50-10)) then begin jij^.wxpos:=1;end;
if(joysticks.y1>(50+10)) then begin jij^.wypos:=maxjoy;end;
if(joysticks.y1<(50-10)) then begin jij^.wypos:=1;end;


{if(v2=1)then begin}
if not(b4=0)then begin jij^.wButtons:=jij^.wButtons+JOY_BUTTON4;end;
if not(b3=0)then begin jij^.wButtons:=jij^.wButtons+JOY_BUTTON3;end;
{end;}
if not(b2=0)then begin jij^.wButtons:=jij^.wButtons+JOY_BUTTON2;end;
if not(b1=0)then begin jij^.wButtons:=jij^.wButtons+JOY_BUTTON1;end;

end;
if(id=1)then begin

{showmessage('='+inttostr(i)+'analog2');}
if(joysticks.x2>(50+10)) then begin jij^.wxpos:=maxjoy;end;
if(joysticks.x2<(50-10)) then begin jij^.wxpos:=1;end;
if(joysticks.y2>(50+10)) then begin jij^.wypos:=maxjoy;end;
if(joysticks.y2<(50-10)) then begin jij^.wypos:=1;end;

{if not(b4=1)then begin jij^.wButtons:=jij^.wButtons+JOY_BUTTON2;end;
if not(b3=1)then begin jij^.wButtons:=jij^.wButtons+JOY_BUTTON1;end;}
if not(b4=0)then begin jij^.wButtons:=jij^.wButtons+JOY_BUTTON2;end;
if not(b3=0)then begin jij^.wButtons:=jij^.wButtons+JOY_BUTTON1;end;
end;
{end else begin end;}
{ji:=nil;}
{sid.free;}
end;

end;

function getconfig:byte; export; begin
result:=0;
 Application.CreateForm(TForm1, Form1);
 if(form1.showmodal=1)then begin result:=1;end;;
end;


function getdevcaps(Id,lparam1,lparam2:longint):byte; export;
var jc:pjoycaps;
begin
result:=0;
if(lparam1>-1) then begin
jc:=pjoycaps(lparam1);
jc^.wmid:=12;jc^.wpid:=12;
{jc^.szpname[3]:='a';}
jc^.szpname[0]:='B';
jc^.szpname[1]:='i';
jc^.szpname[2]:='o';
jc^.szpname[3]:='s';
jc^.szpname[4]:=' ';
jc^.szpname[5]:='J';
jc^.szpname[6]:='o';
jc^.szpname[7]:='y';
jc^.wxmin:=0;jc^.wxmax:=maxjoy;
jc^.wymin:=0;jc^.wymax:=maxjoy;
jc^.wzmin:=0;jc^.wzmax:=0;
jc^.wnumbuttons:=4;
jc^.wperiodmin:=0;jc^.wperiodmax:=0;
end else
begin result:=1;end;
end;




function start:byte;export;
var e,a:longint;
begin
if(started=false)then begin
x:=tinifile.create('gameport.ini');
noj:=strtoint(x.readstring('game','num',inttostr(1)));
started:=true;
{messagebeep(0);}
{showmessage('started joy2');}
e:=0;
gnum:=a;
result:=result+1;
e:=e+1;
dj[1]:=x.readstring('bios','dule joy','1');
{ty[1]:=x.readstring('bios','type','1');}
{strtoint(x.readstring('game'+num,'port',inttostr($200)))};
end;

end;

function stop:byte;export; begin
if(started=true) then begin
x.free;
{messagebeep(random(32));}
{showmessage('stoped joy2');}

end;
started:=false;

end;



function DriverProc(DriverIdentifier: Longint; DriverId: THandle;
Msg: Word; lParam1, lParam2: Longint): Longint; export;
var jc:pjoycaps;
var ji:pjoyinfo;
var s:string;
var noj:byte;
const wdevmax=1;
const power=32;clock1=64;latch=2;
begin
noj:=3;
result:=0;
if(msg=JDD_SETCALIBRATION)then begin result:=mmsyserr_NoError;
end else
if(msg=JDD_GETPOS)then begin
if(inttobin(DriverId)[8]='1') then begin noj:=0;end else begin noj:=1;end;

if(lparam1 > 0) then begin
getpos(noj,lparam1,lparam2);
end else
begin  end;

result:=mmsyserr_NoError;
if DriverID>1 then begin end;
end else
if(msg=JDD_GETDEVCAPS)then begin
if(lparam1>-1) then begin
jc:=pjoycaps(lparam1);
jc^.wmid:=12;
jc^.wpid:=12;
{jc^.szpname[3]:='a';}
jc^.wxmin:=0;
jc^.wxmax:=maxjoy;
jc^.wymin:=0;
jc^.wymax:=maxjoy;
jc^.wzmin:=0;
jc^.wzmax:=0;
jc^.wnumbuttons:=4;
jc^.wperiodmin:=0;
jc^.wperiodmax:=0;
{jc:=nil;}
end;
result:=mmsyserr_NoError;
end else
if(msg=JDD_GETNUMDEVS)then begin
result:=1;
x:=tinifile.create('gameport.ini');
num:='1';
if(x.readstring('bios','dule joy','0')='2')then begin
result:=2;
end;
if(started=false)then begin x.free;end;
end else

{if(msg=DRV_RESERVED)then begin showmessage('reserved');msg:=msg-DRV_RESERVED;
msg:=msg-DRV_RESERVED;
end else
if(msg=DRV_POWER)then begin showmessage('power');msg:=msg-DRV_POWER;end else
if(msg=DRV_EXITAPPLICATION)then begin showmessage('exitapplication');msg:=msg-DRV_EXITAPPLICATION;end else
if(msg=DRV_EXITSESSION)then begin msg:=msg-DRV_EXITSESSION;end else}
if(msg=DRV_REMOVE)then begin  result:=1;
si:=tinifile.create('system.ini');
if ((si.readstring('drivers','joystick','none'))='joy3.dll') then begin
si.writestring('drivers','joystick','');
end else begin
showmessage((si.readstring('drivers','joystick','none')));
end;
si.free;
end else
if(msg=DRV_INSTALL)then begin result:=1;showmessage('restart?');end else
if(msg=DRV_QUERYCONFIGURE)then begin result:=1; end else
if(msg=DRV_CONFIGURE)then begin
 Application.Title := 'bios joystick driver';
  Application.CreateForm(TForm1, Form1);
  if(form1.showmodal=1)then begin end;;
result:=1;end else
if(msg=DRV_FREE)then begin  result:=1;end else
if(msg=DRV_DISABLE)then begin result:=1;end else
if(msg=DRV_CLOSE)then begin  result:=1;end else
if(msg=DRV_OPEN)then begin
result:=2;
x:=tinifile.create('gameport.ini');
dj[1]:=x.readstring('bios','dule joy','1');
x.free;
{if (lParam2 < wDevMax) then begin result:=(lParam2 + 1)end else begin  result:=0;end;
DriverId:=0;}
end else
if(msg=DRV_ENABLE)then begin result:=1;DriverId:=0;end else
if(msg=DRV_LOAD) then begin result:=1;DriverId:=0;end else
begin
result:=defDriverProc(DriverIdentifier,DriverId,Msg, lParam1, lParam2);
end;

end;




exports getpos,getnumdevs,getdevcaps,getconfig,start,stop,driverproc;

begin
{  Application.CreateForm(TForm1, Form1);
  Application.Run;}
end. 
