unit Unit1;

interface

uses
  inifiles,SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Grids, Buttons, StdCtrls,  Spin;
  const JoystickAButton1 = $10;
      JoystickAButton2 = $20;
      JoystickBButton1 = $40;
      JoystickBButton2 = $80;
      JoystickAAxisX   = $01;
      JoystickAAxisY   = $02;
      JoystickBAxisX   = $04;
      JoystickBAxisY   = $08;
var num:string;
var v:longint;
const
JDD_GETNUMDEVS :   longint=  DRV_RESERVED+$0001;
JDD_GETDEVCAPS :  longint=   DRV_RESERVED+$0002;
JDD_GETPOS      :  longint=  DRV_RESERVED+$0101;
JDD_SETCALIBRATION :longint= DRV_RESERVED+$0102;
const maxjoy=$FFFA;
var running:boolean;
var ghInstance:longint;
{2305;}
var b1,b2,b3,b4,x1,y1,x2,y2:longint;
var c,p:longint;
const JOYSTICKPORT = $1201;
Type
  TJoyStick = Record
                x1,x2,y1,y2 : word; {x,y position values}
                a,b,c,d : boolean;  {boolean button values}
                btns : byte;        {numeric button value}
              end;

var Joysticks : Tjoystick;



type
  TForm1 = class(TForm)
    Timer1: TTimer;
    sg: TStringGrid;
    BitBtn1: TBitBtn;
    CheckBox1: TCheckBox;
    procedure Timer1Timer(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
function inttobin(Value: Longint): string;
var
  Ch: Char;
begin
   result:='';
  repeat
    Ch :='0';
    Inc(Ch, Value mod 2);
    if Ch >'9' then Inc(Ch, 7);
    Insert( Ch, Result, 1);
    Value :=Value div 2;
  until Value =0;
end;


function inttobin2(Value: Longint): string;
var
  Ch: Char;
  var x:byte;
begin
  Result :='';
  repeat
    Ch :='0';
    Inc(Ch, Value mod 2);
    if Ch >'9' then Inc(Ch, 7);
    Insert( Ch, Result, 1);
    Value :=Value div 2;
  until Value =0;
  while length(result)<8 do begin
result:='0'+result;
  end;
end;

Function ReadJoyStick : TJoyStick;
var
  x1,x2,y1,y2 :word;
  btns : byte;
begin
   asm              { BIOS call to read joystick (int$15)      }
     MOV AH, $84    { only permitted in 16bit code ie Delphi 1 }
     MOV DX, $0001  { for 32bit code use direct X instead.     }
     INT $15
     MOV x1, AX
     MOV y1, BX
     MOV x2, CX
     MOV y2, DX
     MOV AH, $84
     MOV DX, $0000
     INT $15
     MOV btns, AL
   end;
   result.x1:=x1;
   result.y1:=y1;
   result.x2:=x2;
   result.y2:=y2;
   result.a := not(btns and 16 = 16);
   result.b := not(btns and 32 = 32);
   result.c := not(btns and 64 = 64);
   result.d := not(btns and 128 = 128);
   result.btns := btns;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var b1,b2,b3,b4,x1,y1,x2,y2:longint;
var v:byte;
var c,p:longint;
var ports,port2:longint;
begin
JoySticks := readJoyStick;
c:=0;p:=50;b1:=0;b2:=0;b3:=0;b4:=0;x1:=0;y1:=0;x2:=0;y2:=0;
x1:=joysticks.x1;
y1:=joysticks.y1;
x2:=joysticks.x2;
y2:=joysticks.y2;
{form1.caption:=inttobin2(v);}
v:= joysticks.btns;
c:=c+1;
if(inttobin2(v)[7]='1')then begin x1:=x1+1;end;
if(inttobin2(v)[8]='1')then begin y1:=y1+1;end;
if(inttobin2(v)[5]='1')then begin x2:=x2+1;end;
if(inttobin2(v)[6]='1')then begin y2:=y2+1;end;
if(joysticks.a=true)then begin b1:=1;end;
if(joysticks.b=true)then begin b2:=1;end;
if(joysticks.c=true)then begin b3:=1;end;
if(joysticks.d=true)then begin b4:=1;end;
{if(inttobin2(v)[3]='1')then begin b2:=1;end;
if(inttobin2(v)[2]='1')then begin b3:=1;end;
if(inttobin2(v)[1]='1')then begin b4:=1;end;
 }
sg.cells[1,0]:=inttostr(b1);
sg.cells[2,0]:=inttostr(b2);
sg.cells[3,0]:=inttostr(b3);
sg.cells[4,0]:=inttostr(b4);
sg.cells[1,1]:=inttostr(x1);
sg.cells[2,1]:=inttostr(y1);
sg.cells[3,1]:=inttostr(x2);
sg.cells[4,1]:=inttostr(y2);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var b1,b2,b3,b4,x1,y1,x2,y2:longint;
begin
end;

procedure TForm1.Button1Click(Sender: TObject);
var x:tinifile;
begin
x:=tinifile.create('gameport.ini');
{x.writestring('game'+num,'port',inttostr(h.value));}
x.free;
end;

procedure TForm1.FormCreate(Sender: TObject);
var x:tinifile;y:longint;
begin
x:=tinifile.create('gameport.ini');
y:=strtoint(x.readstring('game','num',inttostr(0)));
if(y=0)then begin
y:=1;
end;
{h.value:=strtoint(x.readstring('game'+num,'port',inttostr($200)));}
if(x.readstring('bios','dule joy','0')='2')then begin
checkbox1.checked:=true;
end else begin
checkbox1.checked:=false;
end;

if(y>1)then begin
{spinedit1.maxvalue:=y;}
{spinedit1.visible:=true;}
end;

x.free;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
form1.close;
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
var x:tinifile;
begin
checkbox1.visible:=false;
x:=tinifile.create('gameport.ini');
x.writestring('game'+num,'type','0');
x.writestring('game'+num,'dule joy','0');
x.free;
end;


procedure TForm1.RadioButton2Click(Sender: TObject);
var x:tinifile;
begin
checkbox1.visible:=true;
x:=tinifile.create('gameport.ini');
x.writestring('game'+num,'type','1');
x.free;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
var wi:tinifile;
begin
{num:=inttostr(spinedit1.value);}
wi:=tinifile.create('gameport.ini');
if(checkbox1.checked=true)then begin
wi.writestring('bios','dule joy','2');
end else begin
wi.writestring('bios','dule joy','1');
end;
wi.free;
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
var x:tinifile;y:longint;
begin

{num:=inttostr(spinedit1.value);}
x:=tinifile.create('gameport.ini');

{h.value:=strtoint(x.readstring('game'+num,'port',inttostr($200)));}

if(x.readstring('game'+num,'dule joy','0')='1')then begin
checkbox1.checked:=true;
end else begin
checkbox1.checked:=false;
end;


x.free;

end;

end.
